int tipo_funcion;             // 0  = Poisson,  1== Conveccion Difusion
double (*fnc_ptr)(double,double,double,int);      // MQ o TPS


#define POLINOMIO

//----------------------------------------------------------------------------------------------------
void  interpola_sol(double *x, double *y, double *lambda,int m,double *X, double *Y, double *sol_refinada, int N)
{
double xc,yc;
double s;

 for(int i=0;i<N;i++)
 {
  s=0.0;
   for(int j=0;j<m;j++)
   {
      s += lambda[j]*fnc_ptr(X[i]-x[j],Y[i]-y[j],0,0);
   }
   xc = X[i];
   yc = Y[i];

 #ifdef POLINOMIO
    s = s + lambda[m];
    s = s + lambda[m+1]*(xc);
    s = s + lambda[m+2]*(yc);
    s = s + lambda[m+3]*(xc*yc);
    s = s + lambda[m+4]*(xc*xc);
    s = s + lambda[m+5]*(yc*yc);
 #endif
    sol_refinada[i] = s;
 }
}

//----------------------------------------------------------------------------------------------------
inline double  calc_error(double xc, double yc,  double *x, double *y, double *lambda, int N)
{
  register int j;
  double s;
  double *ptr_lambda = lambda;
  double *ptr_x = x;
  double *ptr_y = y;

   s=0.0;
   for(j=0;j<N;j++)
   {
      s=s+ (*ptr_lambda)*fnc_ptr(xc-(*ptr_x),yc-(*ptr_y),0,0);
      ptr_lambda++;
      ptr_x++;
      ptr_y++;
   }

 #ifdef POLINOMIO
    s = s + lambda[N];
    s = s + lambda[N+1]*(xc);
    s = s + lambda[N+2]*(yc);
    s = s + lambda[N+3]*(xc*yc);
    s = s + lambda[N+4]*(xc*xc);
    s = s + lambda[N+5]*(yc*yc);
 #endif
  return s;
}



//----------------------------------------------------------------------------------------------------
// error[myRank]=calc_error(x[myRank],y[myRank],lambda[myRank],sol_numerica[myRank],sol_real[myRank],ni[myRank],m[myRank]);
double  calc_error(double *x, double *y, double *lambda, double *sol, int ni, int m)
{
 double error,s;
 double *fx;


 fx  = make_dvector(m);

//Para los nodos interiores
 for(int i=0;i<ni;i++)
 {
  s=0.0;
   for(int j=0;j<m;j++)
   {
      s=s+lambda[j]*fnc_ptr(x[i]-x[j],y[i]-y[j],0,0);
   }
    int N;
    N=m;

 #ifdef POLINOMIO
    s = s + lambda[N];
    s = s + lambda[N+1]*(x[i]);
    s = s + lambda[N+2]*(y[i]);
    s = s + lambda[N+3]*(x[i]*y[i]);
    s = s + lambda[N+4]*(x[i]*x[i]);
    s = s + lambda[N+5]*(y[i]*y[i]);
 #endif


     sol[i]=s;

     fx[i]=u(x[i],y[i]);
   }

//Para los nodos frontera
 for(int i=ni;i<m;i++)
 {
  s=0.0;
   for(int j=0;j<m;j++)
   {
     s=s+lambda[j]*fnc_ptr(x[i]-x[j],y[i]-y[j],0,0);
   }
//case 2:    ///   Phi + 1 + x + y + x*y + x*x + y*y
   int N;
   N=m;


 #ifdef POLINOMIO
    s = s + lambda[N];
    s = s + lambda[N+1]*(x[i]);
    s = s + lambda[N+2]*(y[i]);
    s = s + lambda[N+3]*(x[i]*y[i]);
    s = s + lambda[N+4]*(x[i]*x[i]);
    s = s + lambda[N+5]*(y[i]*y[i]);
 #endif


     sol[i]=s;
     fx[i]=u(x[i],y[i]);
   }

  error = calc_rms(sol,fx,m);

  free_dvector(fx);

  return error;
}

//----------------------------------------------------------------------------------------------------------------

 int     info[100000][4];  
     
int resuelve_ddmTPSP6(int iteracion,int Party, Subdominio dominios[MAX_SUBDOMAINS],int savefiles)
{
//Las variables estatica
 int    i,j;
 FILE   *out;
 char   filename[128]; 
 int    myRank;
 double error_paro;
 int    max_iters;
 int    P;
 int     cont_info;
//los vectores dinamicos
 double  *cond;
 int     *m,*ni; 
  
//Las variables dinamica
  double *x[MAX_SUBDOMAINS],*y[MAX_SUBDOMAINS];
  int    *key[MAX_SUBDOMAINS],*tipo[MAX_SUBDOMAINS];
  double **A[MAX_SUBDOMAINS];
  double *lambda[MAX_SUBDOMAINS],*fx[MAX_SUBDOMAINS];
  double *sol_numerica[MAX_SUBDOMAINS];
  double *sol_real[MAX_SUBDOMAINS];
  int    *pivot_index[MAX_SUBDOMAINS];
 

  P=0;
 #ifdef POLINOMIO
    P=6;
 #endif 
 
 fnc_ptr     = phitps42;
 max_iters   = 300;
 error_paro  = 0.001;

 
 
 printf("DDM with TPS with Pol=%d\n",P);
  
 
//Determino el tipo de funcion a resolver
   printf("tipo  EDP =  Poisson\n");


//Creo los arreglos dinamicos
  m = make_ivector(Party);
 ni = make_ivector(Party);
cond= make_dvector(Party); 

//Asigno el tamanio de cada subdominio
 for(int myRank=0;myRank<Party;myRank++)
 {
    m[myRank]   = dominios[myRank].n;
 }

//Cuento cuanta memoria voy a utilizar
double suma=0;
for(myRank=0; myRank<Party; myRank++)
{
  suma = suma  + sizeof(double)*(m[myRank]*3); //x,y,ind

  
  suma = suma  + sizeof(int)*(m[myRank]*2);    //sol_numerica,sol_real  
  

  suma = suma  + sizeof(double)*((m[myRank]+P)*(m[myRank]+P)); //A    
  suma = suma  + sizeof(double)*((m[myRank]+P)*2); //lambda,fx
  suma = suma  + sizeof(int)*((m[myRank]+P));      //pivot_index

}

 
 printf("Requiero de memoria = %f  Megas \n",suma/1000000.0);



//Creo la memoria dinamica
 for(int myRank=0;myRank<Party;myRank++)
 {
  x[myRank]    = make_dvector(m[myRank]);
  y[myRank]    = make_dvector(m[myRank]);
  tipo[myRank] = make_ivector(m[myRank]);
  key[myRank]  = make_ivector(m[myRank]);  
 }

 
//Cargo/Asigno cada subdominio a memoria: ya estan ordenados con respecto
//del tipo de nodo
  double xc,yc;
  int    tipo_nodo;
 for(int myRank=0;myRank<Party;myRank++)
 {
   for(int i=0;i<m[myRank];i++)
   {
     xc        = dominios[myRank].x[i];
     yc        = dominios[myRank].y[i];     
     tipo_nodo = dominios[myRank].tipo[i];

     x[myRank][i]    = xc;
     y[myRank][i]    = yc;
     tipo[myRank][i] = tipo_nodo;
     key[myRank][i]  = dominios[myRank].key[i];
   }
 }


//Cuento el numero de nodos en cada subdominio
//Cargo todos los nodos ... jeje
for(myRank=0; myRank<Party; myRank++)
{
int cont_interior=0;
int cont_actualiza=0;
int cont_real=0;
int cont_artificial=0;


   for(int i=0;i<m[myRank];i++)
   {
     if(tipo[myRank][i]==INTERIOR)             cont_interior++;
     if(tipo[myRank][i]==FRONTERA_REAL)        cont_real++;
     if(tipo[myRank][i]==FRONTERA_ARTIFICIAL)  cont_artificial++;
   }


   //printf("Proceso : %d, interior=%d,  artificial=%d, frontera_real=%d\n",
  //         myRank,cont_interior, cont_artificial,cont_real);

//defino de nuevo el tipo de nodos
   ni[myRank] = cont_interior;

}


//*************************************************************************
//Determino que nodos actualizan a la frontera artificial de cada
//subdominio.
int band;
cont_info=0;


for(myRank=0; myRank<Party; myRank++)
{
  for(int i=0;i<m[myRank];i++)
  {
   if(tipo[myRank][i]==FRONTERA_ARTIFICIAL)
   {
     //este nodo es frontera_artificial, asi que busco en el resto de los
     //subdominios quien lo actualiza
       band=0;
       for(int ip_der=0; ip_der<Party;ip_der++)
       {
         if(ip_der!=myRank)
         {
           for(int j=0;j<m[ip_der];j++)
           {
             if(key[myRank][i] == key[ip_der][j])
              if(tipo[ip_der][j]==INTERIOR  /*| tipo[ip_der][j]==FRONTERA_REAL*/ )
             {
               band=1;
               // almaceno la informacion.....jeje
                  info[cont_info][0] = ip_der;  // subdominio que envia la informacion
                  info[cont_info][1] = j;       // el indice
                  info[cont_info][2] = myRank;  //subdominio que recibe la informacion
                  info[cont_info][3] = i;       // indica
		  
		  //printf("%d -> %d | %d %d\n",ip_der+1,myRank+1,key[ip_der][j],key[myRank][i]);
		  
                  cont_info++;
  if((cont_info+2)>=100000){
    printf("ERROR: el vector info en %s no alcanza %d.\n",__FILE__,cont_info);
    printf(" cambie el valor asignado.\n");
    exit(1);    
  }

             }
           }
         }
       }//for(ip_der=0; ip_der<Party;ip_der++)
      if(band==0){
       printf("ERROR: existe un nodo en Dominio=[%d] en posicion=%d (%f,%f) no actualizado.\n\n",myRank+1,i+1,x[myRank][i],y[myRank][i]);
       exit(1);
      }
   }
  }
}


//*************************************************************************


//Contruyo las matrices para hacer Uxx+Uyy=f(x,y)
 double ux,uy,uxx_yy;
for(myRank=0; myRank<Party; myRank++)
{
  A[myRank]            = make_dmatrix(m[myRank]+P,m[myRank]+P);
  lambda[myRank]       = make_dvector(m[myRank]+P);
  fx[myRank]           = make_dvector(m[myRank]+P);
  pivot_index[myRank]  = make_ivector(m[myRank]+P);

  sol_numerica[myRank] = make_dvector(m[myRank]);
  sol_real[myRank]     = make_dvector(m[myRank]);
}

//Lleno de zeros
for(myRank=0; myRank<Party; myRank++)
{
  for(i=0;i<(m[myRank]+P);i++)
  {
    for( j=0;j<(m[myRank]+P);j++)
    {
      A[myRank][i][j]=0.0;
    }
   fx[myRank][i]=0.0;
  }
}


for(myRank=0; myRank<Party; myRank++)
{
//Nodos interiores
  for(i=0;i<ni[myRank];i++)
  {

    for( j=0;j<m[myRank];j++)
    {
         uxx_yy =fnc_ptr(x[myRank][i]-x[myRank][j],y[myRank][i]-y[myRank][j],0,5);
         A[myRank][i][j]=  uxx_yy;

    }
     fx[myRank][i]=uxx(x[myRank][i],y[myRank][i]); // nodo interior
     //Para poison
//     case 2: // Phi + 1 + x + y + x*y + x*x + y*y


int N;
double xc,yc;
xc = x[myRank][i];
yc = y[myRank][i];
N=m[myRank];

 #ifdef POLINOMIO
A[myRank][i][N+0]=0.0;
A[myRank][i][N+1]=0.0;
A[myRank][i][N+2]=0.0;
A[myRank][i][N+3]=0.0;
A[myRank][i][N+4]=2.0;
A[myRank][i][N+5]=2.0;
#endif


//Se desborda el horror...bububu

//A[myRank][N+0][i]=0.0;
//A[myRank][N+1][i]=0.0;
//A[myRank][N+2][i]=0.0;
//A[myRank][N+3][i]=0.0;
//A[myRank][N+4][i]=2.0;
//A[myRank][N+5][i]=2.0;



#ifdef POLINOMIO
//Si jala
A[myRank][N+0][i]= 1.0;
A[myRank][N+1][i]= xc;
A[myRank][N+2][i]= yc;
A[myRank][N+3][i]= xc*yc;
A[myRank][N+4][i]= xc*xc;
A[myRank][N+5][i]= yc*yc;
#endif

}//Nodos interiores


//Nodos frontera: frontera_real + frontera_artificial
  for( i=ni[myRank];i<m[myRank];i++)
  {
    for( j=0;j<m[myRank];j++)
    {
      A[myRank][i][j]=fnc_ptr(x[myRank][i]-x[myRank][j],y[myRank][i]-y[myRank][j],0,0);
    }
     fx[myRank][i]=u(x[myRank][i],y[myRank][i]);  // nodo frontera
//case 2:
//Polinomio: Nodos Frontera  Phi + 1 + x + y + x*y + x*x + y*y
int N;
double xc,yc;
xc = x[myRank][i];
yc = y[myRank][i];
N=m[myRank];


#ifdef POLINOMIO
A[myRank][i][N+0]= 1.0;
A[myRank][i][N+1]= xc;
A[myRank][i][N+2]= yc;
A[myRank][i][N+3]= xc*yc;
A[myRank][i][N+4]= xc*xc;
A[myRank][i][N+5]= yc*yc;

A[myRank][N+0][i]= 1.0;
A[myRank][N+1][i]= xc;
A[myRank][N+2][i]= yc;
A[myRank][N+3][i]= xc*yc;
A[myRank][N+4][i]= xc*xc;
A[myRank][N+5][i]= yc*yc;

#endif
 } ////Nodos frontera
   Factor(A[myRank],m[myRank]+P,&cond[myRank],pivot_index[myRank]);


   
    // printf("[%d] cond=%e ",myRank,cond[myRank]);
      
   // if(!(myRank%3))
   //   printf("\n");

}
 printf("\n\n");


for(myRank=0; myRank<Party; myRank++)
{
  for(i=0;i<m[myRank];i++)
  {
    sol_real[myRank][i] = u(x[myRank][i],y[myRank][i]) ;
  }
}


// Asigno a 0 los nodos que no son frontera_artificial
// Salvo a disco dichos nodos
for(myRank=0; myRank<Party; myRank++)
{
  for( i=0;i<m[myRank];i++)
  {
    if(tipo[myRank][i]==FRONTERA_ARTIFICIAL) fx[myRank][i]= 0.0;
  }
}


 int        paro=0;
 double error[MAX_SUBDOMAINS];
 double e_inf[MAX_SUBDOMAINS];
 double s_dif;
 double s_dif_old;
 int    ip_xc;

 s_dif_old=0;


 paro=0;
 s_dif_old=0;




for(int iter=0; iter<max_iters & (paro==0); iter++)
{
 s_dif=0;
   //Limpio los buffers de los errores
      for(myRank=0; myRank<Party; myRank++) error[myRank]=e_inf[myRank]=0;

 //Barro todos los dominios
   for(myRank=0; myRank<Party; myRank++)
  {
    for( i=m[myRank];i<(m[myRank]+P);i++){ fx[myRank][i]=0.0;}
   
         //Resuelvo el sistema
           copy(fx[myRank],m[myRank]+P,lambda[myRank]);
           Solve(A[myRank],m[myRank]+P,pivot_index[myRank],lambda[myRank]); // out --> fx=lambda

       //Calculo el error y a la vez obtengo la soluci\'on u(x,y)
 //error[myRank]=calc_error(x[myRank],y[myRank],lambda[myRank],sol_numerica[myRank],ni[myRank],m[myRank]);
 //e_inf[myRank]=calc_einf(sol_numerica[myRank],sol_real[myRank],m[myRank]);


 
         
//New..new..new
//Reconstruyo la solucion solo en los puntos que quiero enviar hacia el
//otro subdominio
   int ip;
   double xcip,ycip;
   double valor;

   for(int i=0;i<cont_info;i++)
   {
         if(info[i][0]==myRank)
         {
	       ip   = info[i][1];
	       xcip = x[myRank][ip];
	       ycip = y[myRank][ip];

	       valor = calc_error(xcip,ycip,x[myRank], y[myRank],lambda[myRank],m[myRank]);

              sol_numerica[myRank][ip] = valor;
         }
   }


// Comienza el intercambio de informacion entre particiones vecinas
//Actualizo los datos de frontera artificial aumentada
   for(int i=0;i<cont_info;i++)
   {
         if(info[i][0]==myRank)
         {
     	    s_dif=s_dif + fabs(fx[info[i][2]][info[i][3]]-sol_numerica[myRank][info[i][1]]);
            fx[info[i][2]][info[i][3]] = sol_numerica[myRank][info[i][1]];
         }
   }

}  // myRank

  double rms=0;
   for(int i=0; i<Party; i++)	rms = rms + error[i];

   double error_inf;
   maximo(e_inf,myRank,&error_inf);


  double diff_suma;

  if(iter==0)  diff_suma=s_dif;
  else  diff_suma=fabs(s_dif_old-s_dif);

  s_dif_old=s_dif;

 if(!(iter%5))
    printf("Iter=%d rms=%f e_inf=%f  diff_s_dif=%f  with diff=%f\n",iter,rms/double(Party),error_inf,diff_suma,s_dif);

 //Pregunto si ya converge el error residual o el error de las fronteras artificiales
   double mem_sdif,mem_residuo;
  if(diff_suma<error_paro)       paro=1;
 

   cfg.iter  = iter;   

}//for(int iter=0; iter<2500; iter++)


  
  
//Calculo el error en cada subdominioBarro todos los dominios
  for(myRank=0; myRank<Party; myRank++)
  {
    error[myRank]=calc_error(x[myRank],y[myRank],lambda[myRank],sol_numerica[myRank],ni[myRank],m[myRank]);
    e_inf[myRank]=calc_einf(sol_numerica[myRank],sol_real[myRank],m[myRank]);    
  }
   double error_inf;
   
   double rms=0;
   for(int i=0; i<Party; i++)	rms = rms + error[i];   
   rms = rms /double(Party);
   
   maximo(e_inf,Party,&error_inf);  
   
   printf("\nERROR_RMS = %f  ERROR_INF = %f\n",rms,error_inf);
   
   cfg.e_rms = rms;
   cfg.e_inf = error_inf;
   
   
// Muestro el error residual
for(myRank=0; myRank<Party; myRank++)
{
  //printf("[%d] rms = %.7f  e_inf = %f\n",myRank,error[myRank],e_inf[myRank]);
}

 //printf("ERROR_RMS = %f  ERROR_INF = %f\n",rms,error_inf);

 
//-----------------------------------------------------------------------------------------------------
//Asigno la solucion obtenida en cada subdomino
 for(int myRank=0;myRank<Party;myRank++)
 {
   for(int i=0;i<m[myRank];i++)
   {
     dominios[myRank].solucion[i] = sol_numerica[myRank][i];
   }  
 } 
   
 
if(savefiles==1)
{   
 for(int myRank=0;myRank<Party;myRank++)     
  dominios[myRank].gnu_save_solucion(myRank+1);     
}

tocprint();


//Libero la memoria dinamica reservada
for(myRank=0; myRank<Party; myRank++)
{
 free_dvector(x[myRank]);
 free_dvector(y[myRank]);
 free_ivector(tipo[myRank]);
 free_ivector(key[myRank]);

 free_dmatrix(A[myRank],m[myRank]+P);
 free_dvector(lambda[myRank]);
 free_dvector(fx[myRank]);
 free_ivector(pivot_index[myRank]);

 free_dvector(sol_numerica[myRank]);
 free_dvector(sol_real[myRank]);
}
 free_ivector(m);
 free_ivector(ni);
 free_dvector(cond);



 return 0;
}





