/*
  This software is under the license GNU.

  Jose Antonio Munioz Gomez
     jantonio@inaoep.mx
       2004 -  INAOEP
*/

#ifndef JAG_MEM_H_
#define JAG_MEM_H_

#define make_dmatrix( m , n )  make_dmatrix_lf( m , n , __LINE__,__FILE__)
#define make_smatrix( m , n )  make_smatrix_lf( m , n , __LINE__,__FILE__)
#define make_imatrix( m , n )  make_imatrix_lf( m , n , __LINE__,__FILE__)
#define make_dvector( n )      make_dvector_lf( n , __LINE__,__FILE__)
#define make_svector( n )      make_svector_lf( n , __LINE__,__FILE__)
#define make_ivector( n )      make_ivector_lf( n , __LINE__,__FILE__)


#define free_dmatrix( x , n ) free_dmatrix_lf( x , n )
#define free_smatrix( x , n ) free_smatrix_lf( x , n )
#define free_imatrix( x , n ) free_imatrix_lf( x , n )
#define free_dvector( x )     free_dvector_lf( x )
#define free_svector( x )     free_svector_lf( x )
#define free_ivector( x )     free_ivector_lf( x )


double **make_dmatrix_lf(int m, int n, int line,char *file);
float  **make_smatrix_lf(int m, int n, int line,char *file);
int    **make_imatrix_lf(int m, int n, int line,char *file);
double  *make_dvector_lf(int n, int line,char *file);
float   *make_svector_lf(int n, int line,char *file);
int     *make_ivector_lf(int n, int line,char *file);


void     free_dmatrix_lf(double **a,int m);
void     free_smatrix_lf(float **a, int m);
void     free_imatrix_lf(int   **a, int m);
void     free_dvector_lf(double *x);
void     free_svector_lf(float  *x);
void     free_ivector_lf(int    *x);

#endif


