#include "jag_phi.h"
#include <math.h>
//-------------------------------------------------------------------------


double phitps4(double r,double c,int op)
//% r  =  (x-xi)
//% op =  0,1,2: function original, 1a derivate, 2a derivate
//%
//% phi(r)=r^4*log(r)
//
//% Jose Antonio Munioz Gomez
//% Febrero - 2004
//% INAOEP
//% Revisada 6-Marzo-2004 por AMG
//%
//% Con Mathematica se validaron las derivadas, por si tenia algun error manual.
{
double z;

z = 0;

switch(op)
{
 case 0:
      if(r==0)
         z=0;
      else
         z=(r*r*r*r)*log(sqrt(r*r));
      break;
 case 1:
      if(r==0)
         z=0;
      else
            z= (r*r*r)+4*(r*r*r)*log(sqrt(r*r));
      break;
 case 2:
      if(r==0)
         z=0;
      else
        //%  z=(r^2)*(7+6*log(r*r));
           z= 7*(r*r)+12*(r*r)*log(sqrt(r*r));
      break;
}//switch
 return z;
}

//-------------------------------------------------------------------------
double phimq(double r,double c, int op)
{
// return  phitps4(r,c,op);
/*
function z=phimq(r,c,op)
%
% r  =  (x-xi)
% c  =  control parameter
% op =  0,1,2: function original, 1a derivate, 2a derivate

% Jose Antonio Munioz Gomez
% Febrero - 2004
% INAOEP
% Revisado 5-Marzo-2004
c=c*c;
switch op
case 0
      z=sqrt(r*r+c);
case 1
      z=r/(sqrt(r*r+c));
case 2
     z=c/((r*r+c)^(3/2));
end
*/
 double z,den;
 c=c*c;

switch(op)
{
 case 0:
         z=sqrt(r*r+c);
	break;
 case 1: z=r/(sqrt(r*r+c));
        break;
 case 2:
         den = pow(r*r+c,3.0/2.0);
         z=c/den;
        break;
 }//switch

 return z;

}

//-------------------------------------------------------------------------

double phimq2(double r1,double r2, double c, int op)
//function z=phimq2(r1,r2,c,op)
/*
%
% r1 =  (x-xi)
% r2 =  (y-yi)
% c  =  control parameter
% op =
% 0   :  funcion original
% 1   :  1a derivada con respecto de x
% 2   :  2a derivada con respecto de x
% 3   :  1a derivada con respecto de y
% 4   :  2a derivada con respecto de y
% 5   :  2a derivadas Uxx + Uyy


% Jose Antonio Munioz Gomez
% Febrero - 2004
% INAOEP
%
*/

{
double r,z,z1,z2,den1,den2;
c=c*c;

switch(op)
{
 case 0:
        r = r1*r1+r2*r2;
        z=sqrt(r+c);
	break;
 case 1:// %Primera derivada con respecto de x
        r = r1*r1+r2*r2;
        z1=sqrt(r+c);
        z = r1/z1;
	break;
 case 2:// %Segunda derivadad con respecto de x
        r = r1*r1+r2*r2;
        den1=pow(r+c,3./2.);
        den2=sqrt(r+c);
        z = -(r1*r1)/den1 + 1/den2;
	break;
 case 3 ://%Primera derivada con respecto de y
        r = r1*r1+r2*r2;
        z1=sqrt(r+c);
        z = r2/z1;
	break;
 case 4 ://%Segunda derivadad con respecto de y
        r = r1*r1+r2*r2;
        den1=pow(r+c,3./2.);
        den2=sqrt(r+c);
        z = -(r2*r2)/den1 + 1/den2;
	break;
 case 5 ://% Uxx + Uyy
        r = r1*r1+r2*r2;
        den1=pow(r+c,3./2.);
        den2=sqrt(r+c);
        z1 = -(r1*r1)/den1 + 1/den2;

        den1=pow(r+c,3./2.);
        den2=sqrt(r+c);
        z2 = -(r2*r2)/den1 + 1/den2;

        z=z1+z2;
	break;
 }

 return z;
}

////////////////////////////////////////////////////////////////////////

//-------------------------------------------------------------------------

double phitps42(double r1,double r2, double c, int op)
//function z=phitps42(r1,r2,c,op)
/*
%
% r1 =  (x-xi)
% r2 =  (y-yi)
% c  =  control parameter
% op =
% 0   :  funcion original
% 1   :  1a derivada con respecto de x
% 2   :  2a derivada con respecto de x
% 3   :  1a derivada con respecto de y
% 4   :  2a derivada con respecto de y
% 5   :  2a derivadas Uxx + Uyy


% Jose Antonio Munioz Gomez
% Febrero - 2004
% INAOEP
%
*/

{
double r,z;
double CONST=0.0;
    
 r = r1*r1+r2*r2; 
 
switch(op)
{
 case 0: //% Funcion original r^4log(r), r=sqrt(r1*r1+r2*r2)
         //% Revisada 2
        if(r==0)
           z=CONST; 
        else
           z=(r*r)*0.5*log(r);      
	break;
 case 1:// %Primera derivada con respecto de x  
         if(r==0)
            z=CONST; 
          else
            //  % simplify
            //  % z= r1*(r)*(1+2*log(r));          
              z = r1*r+4*r1*r*0.5*log(r);
	break;
 case 2:// %Segunda derivadad con respecto de x
         if(r==0)
            z=CONST; 
         else
             z= 7*(r1*r1)+(r2*r2) + 4*(r1*r1)*log(r) +  2*(r)*log(r);
	break;
 case 3 ://%Primera derivada con respecto de y
        if(r==0)
           z=CONST; 
        else
	  // %  z= r2*(r)*(1+2*log(r));
             z = r2*r + 2*r*r2*log(r) ; 
	break;
 case 4 ://%Segunda derivadad con respecto de y
        if(r==0)
            z=CONST; 
        else
          z= (r1*r1) +7*(r2*r2) + 4*(r)*0.5*log(r) + 8*(r2*r2)*0.5*log(r);
             
	break;
 case 5 ://% Uxx + Uyy
       if(r==0)  
          z=CONST;
        else  
	  // %z=8*r1*r1 + 8*r2*r2 +8*r1*r1*0.5*log(r) + 8*r*0.5*log(r) + 8*r2*r2*0.5*log(r);
           z=8*r1*r1 + 8*r2*r2 +4*r1*r1*log(r) + 4*r*log(r) + 4*r2*r2*log(r);                  
	break;
 }

 return z;



}
 //-------------------------------------------------------------------------
double phitps62(double r1,double r2, double c, int op)
/*
%
% r1 =  (x-xi)
% r2 =  (y-yi)
% c  =  control parameter
% op =
% 0   :  funcion original
% 1   :  1a derivada con respecto de x
% 2   :  2a derivada con respecto de x
% 3   :  1a derivada con respecto de y
% 4   :  2a derivada con respecto de y
% 5   :  2a derivadas Uxx + Uyy
*/
{
double r,z,aux;
double z1,z2;
double CONST=0;

 aux = r1*r1+r2*r2;      
 r   = sqrt(aux); 
switch(op)
{
 case 0: //% Funcion original r^6log(r), r=sqrt(r1*r1+r2*r2)
        if(r==0)
           z=CONST; 
        else
           z=(r*r*r*r*r*r)*0.5*log(aux);      
	break;
 case 1:// %Primera derivada con respecto de x  
         if(r==0)
            z=CONST; 
          else
            z = r1*(aux*aux)*(1+3*log(aux));
	break;
 case 2:// %Segunda derivadad con respecto de x
         if(r==0)
            z=CONST; 
         else
            z=aux*(11*r1*r1+r2*r2+3*(5*r1*r1+r2*r2)*log(aux));
	break;
 case 3 ://%Primera derivada con respecto de y
        if(r==0)
           z=CONST; 
        else
           z =  r2*(aux*aux)*(1+3*log(aux)); 
	break;
 case 4 ://%Segunda derivadad con respecto de y
        if(r==0)
           z=CONST; 
        else
           z=aux*(11*r2*r2+r1*r1+3*(5*r2*r2+r1*r1)*log(aux));;
             
	break;
 case 5 ://% Uxx + Uyy
       if(r==0)  
          z=CONST;
        else{  
	  z1=aux*(11*r1*r1+r2*r2+3*(5*r1*r1+r2*r2)*log(aux));
          z2=aux*(11*r2*r2+r1*r1+3*(5*r2*r2+r1*r1)*log(aux));;	  
          z=z1+z2;
	 }                   
	break;
 }

 return z;

}
 
double phitps82(double r1,double r2, double c, int op)
/*
%
% r1 =  (x-xi)
% r2 =  (y-yi)
% c  =  control parameter
% op =
% 0   :  funcion original
% 1   :  1a derivada con respecto de x
% 2   :  2a derivada con respecto de x
% 3   :  1a derivada con respecto de y
% 4   :  2a derivada con respecto de y
% 5   :  2a derivadas Uxx + Uyy
*/
{
double r,z,aux;
double z1,z2;
double CONST=0;

 aux = r1*r1+r2*r2;      
 r   = sqrt(aux); 
 
switch(op)
{
 case 0: //% Funcion original r^6log(r), r=sqrt(r1*r1+r2*r2)
        if(r==0)
           z=CONST; 
        else
           z=(r*r*r*r*r*r*r*r)*0.5*log(aux);      
	break;
 case 1:// %Primera derivada con respecto de x  
         if(r==0)
            z=CONST; 
          else
            z = r1*(aux*aux*aux)*(1+4*log(aux));
	break;
 case 2:// %Segunda derivadad con respecto de x
         if(r==0)
            z=CONST; 
         else
            z=(aux*aux)*(15*r1*r1+r2*r2+4*(7*r1*r1+r2*r2)*log(aux));
	break;
 case 3 ://%Primera derivada con respecto de y
        if(r==0)
           z=CONST; 
        else
           z =  r2*(aux*aux*aux)*(1+4*log(aux)); 
	break;
 case 4 ://%Segunda derivadad con respecto de y
        if(r==0)
           z=CONST; 
        else
          z=(aux*aux)*(15*r2*r2+r1*r1+4*(7*r2*r2+r1*r1)*log(aux));             
	break;
 case 5 ://% Uxx + Uyy
       if(r==0)  
          z=CONST;
        else{  
          z1=(aux*aux)*(15*r1*r1+r2*r2+4*(7*r1*r1+r2*r2)*log(aux));
          z2=(aux*aux)*(15*r2*r2+r1*r1+4*(7*r2*r2+r1*r1)*log(aux));             	
          z=z1+z2;
	 }                   
	break;
 }
 return z;

}
