function [error,A]=pde3plus2(beta,mu,func,stept,n,c)

% Es Crank-Nicholson
% Debido a que no me sale, lo volvi a programar desde cero.
%
%
% Implementacion de la ecuacion de conveccion-difusion [1]
%
%   Ut = kx*Uxx + ky*Uxx + vx*Ux + vy*Uy
%
%   kx,ky,vx,vy son escalares
%
%[1] Thin Plate Spline Radial Basis Function Scheme for Advection
%    Diffusion Problems. I. Boztosum. A. Charafi. M. Zerroukat,
%    K. Djidjeli.


% Jose Antonio Munioz Gomez
% Marzo - 2004
% INAOEP


% Con signos normales y YA CORREGIDA la ecuacion diferencial parcial
% func='phitps42'
% a=8, b=2; Tmax=0.5, kx=1.4, ky=1.7; vx=1, vy=1;
% Ver Reporte1_4.m




%func = 'phimq2';
%func = 'phitps42';

%Doy las constantes
a  =  8;
b  =  2;


Tmax =0.5;



%kx =  1.4/R;
%ky =  1.7/R;
%vx =  1;
%vy =  1;

kx = beta;
ky = beta;
vx = mu;
vy = mu;
%kx = 1.4;
%ky = 1.7;
%vx = .1;
%vy = .1;



cx = (abs(vx)+sqrt(vx*vx+4*b*kx))/(2*kx);
cy = (abs(vy)+sqrt(vy*vy+4*b*ky))/(2*ky);


%Construyo el grid de puntos
 [P,M,NI]=make_grid(n);

 x = P(1,:);
 y = P(2,:);

%Construyo las matrices de base radial en los puntos adentro de la frontera
 for k=1:NI
   for j=1:M
     r1 = x(k)-x(j);
     r2 = y(k)-y(j);
     A(k,j)   = feval(func,r1,r2,c,0);
     Dx2(k,j) = feval(func,r1,r2,c,2);
     Dy2(k,j) = feval(func,r1,r2,c,4);
     Dx(k,j)  = feval(func,r1,r2,c,1);
     Dy(k,j)  = feval(func,r1,r2,c,3);
   end
   f(k) = a*(exp(-cx*x(k)) +   exp(-cy*y(k)));
 end


%Construyo las matrices de base radial en los puntos de la frontera
 for k=NI+1:M
   for j=1:M
     r1 = x(k)-x(j);
     r2 = y(k)-y(j);
     A(k,j)   = feval(func,r1,r2,c,0);
     Dx2(k,j) = feval(func,r1,r2,c,0);
     Dy2(k,j) = feval(func,r1,r2,c,0);
     Dx(k,j)  = feval(func,r1,r2,c,0);
     Dy(k,j)  = feval(func,r1,r2,c,0);
   end
   f(k) = a*(exp(-cx*x(k)) +   exp(-cy*y(k)));
 end

 if(abs(cond(A))>1e16)
   error=NaN;
   return;
 end


%Resuelvo el sistema inicial
 lambda = A\f';


%Determino otras constantes
ro1 = (kx*stept)/2;
ro2 = (ky*stept)/2;
ro3 = (vx*stept)/2;
ro4 = (vy*stept)/2;

t   = 0;

%Itero sobre el tiempo
while(t<=Tmax)

  H2 = (A -ro1*Dx2 -ro2*Dy2 - ro3*Dx - ro4*Dy);

  H1 = (A +ro1*Dx2 +ro2*Dy2 + ro3*Dx + ro4*Dy)*lambda;

 %Actualizo las fronteras
   for i=NI+1:M
       H1(i) = a*exp(b*t)*(exp(-cx*x(i))+exp(-cy*y(i)));
   end

 %Resuelvo el sistema
  lambda = H2\H1;

 %Incremento el tiempo
   t=t+stept;

end


%Reconstruyo la solucion
for k=1:M
  s=0;
  for j=1:M
     r1 = x(k)-x(j);
     r2 = y(k)-y(j);
     s=s+lambda(j)*feval(func,r1,r2,c,0);
  end
  sol(k)=s;
end

%Paso a forma matricial
 C = make_sol(n,sol);
 h = 1/n;

%Calculo el error

err=0;
cont=0;
 for i=1:n+1
   for j=1:n+1
     xx =  (i-1)*h;
     yy =  (j-1)*h;

     val=a*exp(b*t)*(exp(-cx*xx)+exp(-cy*yy));

     err =err + (C(i,j)-val)^2;
     Analitica(i,j) =val;
     cont=cont+1;
   end
end

 error=sqrt(err/cont);

fprintf(1,'N = %d , rank = %d , cond = %e  , error = %e\n',M,rank(H2),cond(H2),error);


return
%Paso a grafica 3D como en el articulo
k=1;
for i=1:n+1
   for j=1:n+1
     xx =  (i-1)*h;
     yy =  (j-1)*h;
     x(k)=xx;
     y(k)=yy;
     za(k)=Analitica(i,j);
     zn(k)=C(i,j);
     k=k+1;
   end
end

figure;
plot3(x,y,za,'o',x,y,zn,'s');
legend('Analitica','RBF',1);
axis xy
xlabel('X - Axis ');
ylabel('Y - Axis ');
