
typedef struct mesh{
 double *x;
 double *y; 
 int    *tipo;
 int    ni,n,N;
}mesh;	


//--------------------------------------------------------------------
mesh  make_mesh(double xmin,double xmax, double ymin, double ymax, int n)
{
 double *x;	
 double *y; 
 int    *tipo;
 int    N;
 double h;
 double xc,yc;
 int    cont,ni,indi;
 int    i,j;
	
  h = (xmax-xmin)/double(n-1);
  
  N = n*n;

  x  = make_dvector(N);
  y  = make_dvector(N);
tipo = make_ivector(N);
 

cont=0;
ni=0;
 for(i=0;i<n;i++)
 {
  for(j=0;j<n;j++) 
  {
    indi = (i>0 & j>0 & i<(n-1) & j<(n-1))?INTERIOR:FRONTERA_REAL;	   
    xc  = xmin + h*i;
    yc  = ymin + h*j; 

    x[cont]  = xc;
    y[cont]  = yc;    
 tipo[cont]  = indi;
  cont++;

    if(indi==INTERIOR)
      ni++;   
  } 
}  

//Ordeno con respecto del tipo de dato: INTERIOR,FRONTERA_REAL
  quickSort(tipo,x,y,0,N-1);	
  
 mesh malla;
 
  malla.x    = x;  
  malla.y    = y;  
  malla.tipo = tipo;    
  malla.n    = n;
  malla.ni   = ni;  
  malla.N    = n*n;    
  
 return malla;
}


//--------------------------------------------------------------------
void  save_gnu_solucion(char *filename,double *x, double *y, double *sol, int N)
{
  int   i;
  FILE *out;

   out = fopen(filename,"w+");


  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }


   for(i=0;i<N;i++)
     fprintf(out,"%f %f %e\n",x[i],y[i],sol[i]);
  fclose(out);
}
